program Amp2
use sep

!new version, to make an H file as well as the par file
!newer still (oct 2,2003) to take the amps from a single line (ave of three samples) across, rather than 
!picking each amp from a different time on each trace

implicit none
  integer                              :: n1, n2, i2, i1, ii
  real                                 :: tmin, tmax, max, smin, smax, d1, o1, d2, o2, atot, mtot
  real, dimension (:), allocatable     :: amps, maxamps
  real, dimension (:,:), allocatable     :: data
  character (len = 20)                 :: ampfile
  character (len = 7)                  :: buffer

call sep_init()
  call from_history("n1",n1)
  call from_history("n2",n2)
  call from_history("d2",d2)
  call from_history("d1",d1)
  call from_history("o1",o1)
  call from_history("o2",o2)
  call from_param("tmin",tmin)
  call from_param("tmax",tmax)
  call from_param("ampfile",ampfile)

  allocate (data(n1,n2))
  allocate (amps (n2))
  allocate (maxamps(n2))
  call sep_read (data)

maxamps=0 
amps=0

smin=(tmin-o1)/d1 + 1          !does this work right?
smax=(tmax-o1)/d1 + 1

time: do i1=smin,smax
traces:do i2=1,n2
   amps(i2)=(data(i1-1,i2)+data(i1,i2)+data(i1+1,i2))/3
end do traces
   !check for max
      mtot = 0
      atot = 0
   do ii=1,n2
      mtot = mtot + abs(maxamps(ii))
      atot = atot + abs(amps(ii))
   end do
   if (atot > mtot) maxamps = amps
end do time

call to_history ("n1",n2)
call to_history ("n2",1)
call to_history ("n3",1)
call to_history ("label1","offset (m)")
call to_history ("label2","amplitude")
call to_history ("d1",d2)
call to_history ("o1",o2)

out1:do i2 = 1, n2
   write (buffer, "(a,i3.3)" ) 'amp_',i2
!   write(0,*) 'buffer is', buffer
!   write (buffer, "(a)" ) ' '
   call to_history (buffer,maxamps(i2),ampfile)
end do out1
call sep_write(maxamps)

call sep_close ()


deallocate (amps)
deallocate (data)
deallocate (maxamps)



call exit(0)
end program Amp2

