program Clean60hz
  use sep

!Now 3-D!!!  (may 1, 2003)  (but the c-file shit probably doesn't work anymore). 

! Inane Fortran issues resolved:
! 1) Forttran doesn't distinguish betweenn upper and lower case.
! 2) Comment character in F90 is !.
! 3) Be consistant w/ variables, numb-nuts.  dt is different from d1

! win is the length of the estimation window.  must be integer multiple of 0.01666666666.
! so 0.5 works, 0.4, 0.3, 0.25, 0.2, 0.1


implicit none
  integer                          :: n1, n2, n3, i1, i11, i2, i3, m, im, tt, i, j, count
  real                             :: d1, w, t, pi, a1, a2, a3, beta, f0, t1, t2, t3, t4, win
  real, dimension (:), allocatable :: trace_old, trace_new, h
  real, dimension (:, :,:), allocatable :: a, b, c
  character (len = 10) :: buffer
  character (len = 20) :: cfile

call sep_init()
  call from_history("n1",n1)
  call from_history("n2",n2)
  call from_history("n3",n3)
  call from_history("d1",d1)
  call from_param("cfile",cfile)
  call from_param("win",win,0.5)    ! input the length of the estimation window, in secs
  cfile=trim(cfile)
!  call to_history ("c",c,"cfile")
!call sep_close ()

  pi=3.141592654
!  t=0.5                        !length of est. window tau, in secs
  t=win
  tt=t/d1                      ! # of samples in estimation window
  f0=60.                       !dominant frequency in Hz
  w=2*pi*f0                    !dominant freq in radians
  m=(1/(2*d1))/f0              !find all harmonics up to Nyquist
!write(0,*) 'tt is', tt
!write(0,*) 'd1 is', d1


allocate (trace_old (n1))
allocate (trace_new (n1))
allocate (h (n1))
allocate (a (m, n2, n3))
allocate (b (m, n2, n3))
allocate (c (m, n2, n3))

!write(0,*) 'size(a)', size(a)

!write(0,*) 'size(h)', size(h)
h=0; a=0; b=0; c=0
!          write(0,*) 'old trace(1) is', trace_old(1)

panels:do i3 = 1, n3
!   traces:do i2 = 1, 1
    traces:do i2 = 1, n2                    !each trace
     call sep_read (trace_old)
     trace_new = trace_old
     harm:do im = 1, m                  !each harmonic
!    harm:do im = 1, 1
        a1 = t/2 + ((sin (2*im*w*t))/(4*im*w))              !alpha 1
        a2 = (1-cos (2*im*w*t))/(4*im*w)                  !alpha 2
        a3 = t/2 - ((sin (2*im*w*t))/(4*im*w))              !alpha 3
        beta = 1/(a1*a3-a2*a2)                            !beta
         ! write(0,*) 'a1 is', a1
         ! write(0,*) 'a2 is', a2
         ! write(0,*) 'a3 is', a3
         ! write(0,*) 'beta is', beta
         ! write(0,*) 'old trace(1) is', trace_old(1)
         !  write(0,*) 'a is', a (im, i2)
         !  write(0,*) 'b is', b (im, i2)

        time1:do i1 = 1, tt          !integrate over time 0 to tau
           t1=a3*cos(im*w*i1*d1)
           t2=a2*sin(im*w*i1*d1)
           t3=a1*sin(im*w*i1*d1)
           t4=a2*cos(im*w*i1*d1)

        !   write(0,*) 't1 is', t1
        !   write(0,*) 't2 is', t2
        !   write(0,*) 't3 is', t3
        !   write(0,*) 't4 is', t4
        !  write(0,*) 'old trace(1) is', trace_old (i1)

           a (im, i2, i3) = (a (im, i2, i3) + ((beta * trace_old (i1) * d1)*(t1-t2)))
           b (im, i2, i3) = (b (im, i2, i3) + ((beta * trace_old (i1) * d1)*(t3-t4)))

   !        write(0,*) 'a is', a (im, i2)
   !        write(0,*) 'b is', b (im, i2)

         end do time1

         c (im, i2, i3) = sqrt ( (a (im, i2, i3) * a (im, i2, i3)) + (b (im, i2, i3) * b (im, i2, i3)))
    !       write(0,*) 'a is', a (im, i2)
    !       write(0,*) 'b is', b (im, i2)
        time2:do i11 = 1, n1            !solve for harmonic at each time
           h (i11) = (a (im, i2, i3)*cos (im*w*i11*d1)) +(b(im,i2,i3)*sin (im*w*i11*d1))
        end do time2
        trace_new = trace_new - h
      end do harm
     call sep_write (trace_new)
  end do traces
end do panels

!dump the c values to parameter file 'cfile' for later use

!count=0
call to_history ("no_harm",m,cfile)
call to_history ("no_traces",n2,cfile)
out1:do i = 1, m
   out2:do j = 1, n2
     write (buffer, "(a,i3.3,a,i3.3)" ) 'c',i,"_",j
!     count=count+1
!     write (buffer, "(i3.3)") count
     call to_history (buffer,c(i,j),cfile)
   end do out2
end do out1

call sep_close ()


deallocate (trace_old)
deallocate (trace_new)
deallocate (a)
deallocate (b)
deallocate (h)
deallocate (c)

call exit (0)
end program Clean60hz









